#ifndef SAK2V2_PROTOCOL_H
#define SAK2V2_PROTOCOL_H

// Define for sak2v2 serial protocol
#define SAK2V2_MAX_BODY_LEN 256
#define SAK2V2_PACKET_START_C 'S'
#define SAK2V2_PACKET_STOP_C 'T'

// Sak2 Transmitted Messages
#define SAK2V2_ACK_C 'y'
#define SAK2V2_NACK_C 'n'
#define SAK2V2_META_SENSOR_C 'm'
#define SAK2V2_SENSOR_C 'c'
#define SAK2V2_ERROR_C 'e'
#define SAK2V2_INIT_C 'i'
#define SAK2V2_CONFIG_RET_C 'R'
#define SAK2V2_I2C_VALUE 'v'
#define SAK2V2_ANALOG_VALUE 'a'

// Sak2 Receivable Messages
#define SAK2V2_CONFIG_C 'h'
#define SAK2V2_GET_CONFIG_C 'g'
#define SAK2V2_I2C_REQUEST_C 'q'
#define SAK2V2_I2C_READ_C 'r'
#define SAK2V2_I2C_WRITE_C 'w'
#define SAK2V2_ANALOG_REQUEST_C 'l'
#define SAK2V2_START_STREAM_C 's'
#define SAK2V2_TERM_STREAM_C 't'
#define SAK2V2_CLEAR_C 'C'
#define SAK2V2_ECHO_C 'E'

#define SAK2V2_DTYPE_ANALOG 0
#define SAK2V2_DTYPE_I2C 1
#define SAK2V2_DTYPE_SPECIAL 2


#endif


