function [] = check(fileName);
% first run 
% ../../../enchant-base/MultiSignalReader /outout/states > fileName
% ../../AudioFeatures -f SIGNAL_FILE_NAME /output 
% when AudioFeatures stopped -> ^C MultiSignalReader and run check

if (nargin<1)
    disp('Usage: check(fileName)');
    disp('first run:'); 
    disp('../../../enchant-base/MultiSignalReader /outout/states > fileName');
    disp('../../AudioFeatures -f SIGNAL_FILE_NAME /output');
    return;
end


load states_gold.mat;

addpath('../../../matlab/SignalSelector/');
if (~exist('./sig2mat.sh'))
    system('ln -s ../../../matlab/SignalSelector/sig2mat.sh')
end
[suc,dat,lab] = LoadMultiSignalReaderFileUnix(fileName);

feat = dat{1}(:,2:end)';
feat = feat(:);
feat_new = reshape(feat,5,length(feat)/5);
speak = dat{2}(:,2:end)';
speak_new = speak(:);
voiced = dat{3}(:,2:end)';
voiced_new = voiced(:);
    
voiced_new = voiced_new(40:end);
speak_new = speak_new(172:end);

feat_new = feat_new(1:4,:)';


if (length(feat_gold)>length(feat_new))
    feat_gold = feat_gold(1:length(feat_new),:);
else
    feat_new = feat_new(1:length(feat_gold),:);
end

if (length(voiced_gold)> length(voiced_new))
    voiced_gold = voiced_gold(1:length(voiced_new));
else
    voiced_new = voiced_new(1:length(voiced_gold));
end
 
if (length(speak_gold) > length(speak_new))
     speak_gold = speak_gold(1:length(speak_new));
else
    speak_new = speak_new(1:length(speak_new));
end   

display('difference for features: (new-gold)')
ma = max( feat_new- feat_gold);
mi = min( feat_new- feat_gold);
display(['max: ' num2str(ma)]);
display(['min: ' num2str(mi)]);
disp(' ');

feat = [feat_new feat_gold];
cc=corrcoef(feat);
display(['correlation maxpeak ' num2str(cc(1,5))]);
display(['correlation numpeak ' num2str(cc(2,6))]);
display(['correlation spec entropy ' num2str(cc(3,7))]);
display(['correlation energy ' num2str(cc(4,8))]);
disp(' ');

display(['diff for voiced: ' num2str(length(find(voiced_new - voiced_gold ~= -1)))]);
display(['diff for speaking: ' num2str(length(find(speak_new - speak_gold ~= -1)))]);

    
a=1;
