/*************************************************
 * File: clients.h
 * Birth Date: Dec 03, 2003
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 *
 * Copyright (C) 2003 MIT Media Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *************************************************/

#ifndef _CLIENTS_H
#define _CLIENTS_H

#include <enchantment/darray.h>
#include <enchantment/dstring.h>
#include "socket.h"

#include "features.h"

#include "tree-manip.h"

int SendResultNode(ClientIDType *clientID, NodeType *dataNode, 
		   char *callType, char *UNL, char *result);

int SendResultNodeSocket(ClientIDType *clientID, Socket *socket, NodeType *dataNode, 
			 char *callType, char *UNL, char *result);

void SendUpdateNode(ClientIDType *subscriber, NodeType *node, char *UNL,
		    char *publisherName);

int SendNode(ClientIDType *client, Socket *socket, NodeType *node);

int SendNodeToGroup(NodeType *node, NodeType *group);

NodeType *GetClientNode(ClientIDType *clientID);

int ReceiveNode(Socket *socket, NodeType **node);

int HandleNewClient(Socket *socket);

void RemoveClient(ClientIDType *clientID);

#ifndef USE_THREADS
int       ServiceClients(fd_set *p_sockSet);
#endif

#endif
