/*************************************************
 * File: symbols.c
 * Birth Date: 12/3/2003
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 * 
 * Copyright (C) 2002 MIT Media Lab
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *************************************************/

#include <stdlib.h>
#include "symbols.h"
#include "whiteboard-protocol.h"
#include <enchantment/dstring.h>

char *c_initial = NULL, *c_get = NULL, *c_getattr = NULL, 
  *c_signal_init = NULL;
//char *c_create = NULL;
//char *c_document_init = NULL;
char *c_lock = NULL, *c_unlock = NULL, *k_unl = NULL;
char *c_admin = NULL;
char *k_property_encrypt = NULL, *k_type = NULL;
char *c_publish = NULL, *c_unpublish = NULL, *c_subscribe = NULL;
char *c_unsubscribe = NULL;
char *k_operation = NULL;
//char *c_ping = NULL;

char *kv_merge = NULL, *kv_addonly = NULL, *kv_delete = NULL;
char *kv_replace = NULL, *k_auth = NULL;

char *sv_success, *sv_failure, *sv_locked, *sv_error;

void InitSymbols()
{
  if (!c_initial)
    {
      // String constant initialization
      c_initial = InstanceString(C_INITIAL);
      //c_create = InstanceString(C_CREATE);
      c_signal_init = InstanceString(C_SIGNAL_INIT);
      //c_document_init = InstanceString(C_DOCUMENT_INIT);
      //c_ping = InstanceString(C_PING);
      c_get = InstanceString(C_GET);
      c_getattr = InstanceString(C_GETATTR);
      c_lock = InstanceString(C_LOCK);
      c_unlock = InstanceString(C_UNLOCK); 
      c_publish = InstanceString(C_PUBLISH);
      c_subscribe = InstanceString(C_SUBSCRIBE);
      c_unsubscribe = InstanceString(C_UNSUBSCRIBE);
      k_unl = InstanceString(K_UNL);
      k_property_encrypt = InstanceString(K_PROPERTY_ENCRYPT);
      k_operation = InstanceString(K_OPERATION);
      kv_addonly = InstanceString(KV_ADDONLY);
      kv_replace = InstanceString(KV_REPLACE);
      kv_merge = InstanceString(KV_MERGE);
      k_auth = InstanceString(K_AUTH);
      k_type = InstanceString(K_TYPE);
      c_admin = InstanceString(C_ADMIN);
      sv_success = InstanceString(SV_SUCCESS);
      sv_failure = InstanceString(SV_FAILURE);
      sv_locked = InstanceString(SV_LOCKED);
      sv_error = InstanceString(SV_ERROR);
    }
}
